<?php
/*
  $Id: shopping_cart_mod.php
  $Loc: catalog/includes/classes/

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  wholesale (SPPC Lite) 3.0 
  by @raiwa 
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2018 osCommerce

  Released under the GNU General Public License
*/

  if (class_exists('shoppingCart')) {
    class shoppingCartMod extends shoppingCart {

    	public $contents;
      public $total;
      public $weight;
      public $cartID;
      public $content_type;
      public $customer_id;      
        
      public function __construct() { 
      	global $cart;
      	global $customer_id;

        $this->contents = $cart->contents;
        $this->total = $cart->total;
        $this->weight = $cart->weight;
        $this->cartID = $cart->cartID;
        $this->content_type = $cart->content_type;

    	}

        
      public function calculate() {
      global $currencies, $customer_id, $wholesale_group;

      $this->total = 0;
      $this->weight = 0;
      if (!is_array($this->contents)) return 0;

      foreach(array_keys($this->contents) as $products_id) {
        $qty = $this->contents[$products_id]['qty'];

// products price
        $product_query = tep_db_query("select products_id, products_price, products_tax_class_id, products_weight, products_ws_price from products where products_id = '" . (int)$products_id . "'");
        if ($product = tep_db_fetch_array($product_query)) {
          $prid = $product['products_id'];
          $products_tax = tep_get_tax_rate($product['products_tax_class_id']); // apply standard tax
          if ( tep_session_is_registered('customer_id') && defined('MODULE_STORE_WHOLESALE_STATUS') && MODULE_STORE_WHOLESALE_STATUS == 'True' && $wholesale_group > 0 ) {
          	if (MODULE_STORE_WHOLESALE_TAX_EXEMPT == 'True') // exempt wholesale customers from tax
          		$products_tax = 0;  
          	if ($product['products_ws_price'] > 0 ) { // apply individual wholesale price
          		$products_price = $product['products_ws_price'];
          	} else if (MODULE_STORE_WHOLESALE_GLOBAL_DISCOUNT > 0) { // apply global wholesale price discount
          		$products_price = $product['products_price'] - (tep_round($product['products_price'] * MODULE_STORE_WHOLESALE_GLOBAL_DISCOUNT/100, 2));
          	} else { // apply retail price
          	$products_price = $product['products_price'];
          	}
          } else { // apply retail price
          	$products_price = $product['products_price'];
          }
          $products_weight = $product['products_weight'];
          
          $specials_query = tep_db_query("select specials_new_products_price from specials where products_id = '" . (int)$prid . "' and status = '1'");
          if (tep_db_num_rows ($specials_query)) {
            $specials = tep_db_fetch_array($specials_query);
            if ( tep_session_is_registered('customer_id') && defined('MODULE_STORE_WHOLESALE_STATUS') && MODULE_STORE_WHOLESALE_STATUS == 'True' && $wholesale_group > 0) {
            	if ( (defined('MODULE_STORE_WHOLESALE_SPECIAL_PRICE') && MODULE_STORE_WHOLESALE_SPECIAL_PRICE == 'True' && $specials['specials_new_products_price'] < $products_price)
            				|| (MODULE_STORE_WHOLESALE_SPECIAL_PRICE == 'False' && $product['products_ws_price'] == 0 && MODULE_STORE_WHOLESALE_GLOBAL_DISCOUNT == 0) ) {
            		$products_price = $specials['specials_new_products_price']; // apply specials price instead of wholesale price
            	}
            } else {
            	$products_price = $specials['specials_new_products_price']; // apply specials price
            }
          }

          $this->total += $currencies->calculate_price($products_price, $products_tax, $qty);
          $this->weight += ($qty * $products_weight);
        }

// attributes price
        if (isset($this->contents[$products_id]['attributes'])) {
          foreach($this->contents[$products_id]['attributes'] as $option => $value) {
            $attribute_price_query = tep_db_query("select options_values_price, price_prefix, options_values_ws_price from products_attributes where products_id = '" . (int)$prid . "' and options_id = '" . (int)$option . "' and options_values_id = '" . (int)$value . "'");
            $attribute_price = tep_db_fetch_array($attribute_price_query);
            if ( tep_session_is_registered('customer_id') && defined('MODULE_STORE_WHOLESALE_STATUS') && MODULE_STORE_WHOLESALE_STATUS == 'True' && $wholesale_group > 0) { // wholesale attribute price
            	if ( $attribute_price['options_values_ws_price'] != '0') { // apply individual wholesale attribute price
            		if ($attribute_price['price_prefix'] == '+') {
            			$this->total += $currencies->calculate_price($attribute_price['options_values_ws_price'], $products_tax, $qty);
            		} else {
            			$this->total -= $currencies->calculate_price($attribute_price['options_values_ws_price'], $products_tax, $qty);
            		}
            	} else if (MODULE_STORE_WHOLESALE_GLOBAL_DISCOUNT > 0) { // apply global wholesale price discount
            		if ($attribute_price['price_prefix'] == '+') {
            			$this->total += $currencies->calculate_price($attribute_price['options_values_price'] - (tep_round($attribute_price['options_values_price'] * MODULE_STORE_WHOLESALE_GLOBAL_DISCOUNT/100, 2)), $products_tax, $qty);
            		} else {
            			$this->total -= $currencies->calculate_price($attribute_price['options_values_price'] - (tep_round($attribute_price['options_values_price'] * MODULE_STORE_WHOLESALE_GLOBAL_DISCOUNT/100, 2)), $products_tax, $qty);
            		}
            	} else { // apply retail attribute price
            		if ($attribute_price['price_prefix'] == '+') {
            			$this->total += $currencies->calculate_price($attribute_price['options_values_price'], $products_tax, $qty);
            		} else {
            			$this->total -= $currencies->calculate_price($attribute_price['options_values_price'], $products_tax, $qty);
            		}
            	}
						} else { // apply retail attribute price
							if ($attribute_price['price_prefix'] == '+') {
								$this->total += $currencies->calculate_price($attribute_price['options_values_price'], $products_tax, $qty);
							} else {
								$this->total -= $currencies->calculate_price($attribute_price['options_values_price'], $products_tax, $qty);
							}
						}
          }
        }
      }
    }

    public function attributes_price($products_id) {
      global $wholesale_group;
      
      $attributes_price = 0;

      if (isset($this->contents[$products_id]['attributes'])) {
        foreach($this->contents[$products_id]['attributes'] as $option => $value) {
          $attribute_price_query = tep_db_query("select options_values_price, price_prefix, options_values_ws_price from products_attributes where products_id = '" . (int)$products_id . "' and options_id = '" . (int)$option . "' and options_values_id = '" . (int)$value . "'");
          $attribute_price = tep_db_fetch_array($attribute_price_query);
          if ( tep_session_is_registered('customer_id') && defined('MODULE_STORE_WHOLESALE_STATUS') && MODULE_STORE_WHOLESALE_STATUS == 'True' && $wholesale_group > 0) { // wholesale attribute price
            if ( $attribute_price['options_values_ws_price'] != '0') { // apply individual wholesale attribute price
            	if ($attribute_price['price_prefix'] == '+') {
            		$attributes_price += $attribute_price['options_values_ws_price'];
            	} else {
            		$attributes_price -= $attribute_price['options_values_ws_price'];
            	}
            } else if (MODULE_STORE_WHOLESALE_GLOBAL_DISCOUNT > 0) { // apply global wholesale price discount
            	if ($attribute_price['price_prefix'] == '+') {
            		$attributes_price += $attribute_price['options_values_price'] - (tep_round($attribute_price['options_values_price'] * MODULE_STORE_WHOLESALE_GLOBAL_DISCOUNT/100, 2));
            	} else {
            		$attributes_price -= $attribute_price['options_values_price'] - (tep_round($attribute_price['options_values_price'] * MODULE_STORE_WHOLESALE_GLOBAL_DISCOUNT/100, 2));
            	}
            } else { // apply retail attribute price
            	if ($attribute_price['price_prefix'] == '+') {
								$attributes_price += $attribute_price['options_values_price'];
							} else {
								$attributes_price -= $attribute_price['options_values_price'];
							}
            }
					} else { // apply retail attribute price
						if ($attribute_price['price_prefix'] == '+') {
							$attributes_price += $attribute_price['options_values_price'];
						} else {
							$attributes_price -= $attribute_price['options_values_price'];
						}
					}
        }
      }

      return $attributes_price;
    }

    public function get_products() {
      global $languages_id, $customer_id, $wholesale_group;
      
      if (!is_array($this->contents)) return false;

      $products_array = array();
      foreach(array_keys($this->contents) as $products_id) {
        $products_query = tep_db_query("select p.products_id, pd.products_name, p.products_model, p.products_image, p.products_price, p.products_weight, p.products_tax_class_id, p.products_ws_price from products p, products_description pd where p.products_id = '" . (int)$products_id . "' and pd.products_id = p.products_id and pd.language_id = '" . (int)$languages_id . "'");
        if ($products = tep_db_fetch_array($products_query)) {
          $prid = $products['products_id'];
          $products_tax_class_id = $products['products_tax_class_id'];  // apply standard tax
          if ( tep_session_is_registered('customer_id') && defined('MODULE_STORE_WHOLESALE_STATUS') && MODULE_STORE_WHOLESALE_STATUS == 'True' && $wholesale_group > 0 ) {
          	if (MODULE_STORE_WHOLESALE_TAX_EXEMPT == 'True') // exempt wholesale customers from tax
          		$products_tax_class_id = 0;  

          	if ( $products['products_ws_price'] > 0 ) { // apply individual wholesale price
          		$products_price = $products['products_ws_price'];
          	} else if ( MODULE_STORE_WHOLESALE_GLOBAL_DISCOUNT > 0 ) { // apply global wholesale price discount
          		$products_price = $products['products_price'] - (tep_round($products['products_price'] * MODULE_STORE_WHOLESALE_GLOBAL_DISCOUNT/100, 2));
          	} else { // apply retail price
          		$products_price = $products['products_price'];
          	}
          } else { // apply retail price
          	$products_price = $products['products_price'];
          }

          $specials_query = tep_db_query("select specials_new_products_price from specials where products_id = '" . (int)$prid . "' and status = '1'");
          if (tep_db_num_rows($specials_query)) {
            $specials = tep_db_fetch_array($specials_query);
            if ( tep_session_is_registered('customer_id') && defined('MODULE_STORE_WHOLESALE_STATUS') && MODULE_STORE_WHOLESALE_STATUS == 'True' && $wholesale_group > 0) {
            	if ( (defined('MODULE_STORE_WHOLESALE_SPECIAL_PRICE') && MODULE_STORE_WHOLESALE_SPECIAL_PRICE == 'True' && $specials['specials_new_products_price'] < $products_price)
            				|| (MODULE_STORE_WHOLESALE_SPECIAL_PRICE == 'False' && $products['products_ws_price'] == 0 && MODULE_STORE_WHOLESALE_GLOBAL_DISCOUNT == 0) ) {
            		$products_price = $specials['specials_new_products_price']; // apply specials price instead of wholesale price
            	}
            } else {
            	$products_price = $specials['specials_new_products_price']; // apply specials price
            }
          }
          
          $products_array[] = array('id' => $products_id,
                                    'name' => $products['products_name'],
                                    'model' => $products['products_model'],
                                    'image' => $products['products_image'],
                                    'price' => $products_price,
                                    'quantity' => $this->contents[$products_id]['qty'],
                                    'weight' => $products['products_weight'],
                                    'final_price' => ($products_price + $this->attributes_price($products_id)),
                                    'tax_class_id' => $products_tax_class_id,
                                    'attributes' => (isset($this->contents[$products_id]['attributes']) ? $this->contents[$products_id]['attributes'] : ''));
        }
      }
      return $products_array;
    }
   }
  }
  
?>
