<?php
/*
  $Id: cm_header_wholesale.php
  $Loc: catalog/includes/modules/content/header/

  wholesale (SPPC Lite) 4.0.0 
  by @raiwa 
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2019 Rainer Schmied
  All rights reserved.﻿﻿

  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

  3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

  class cm_header_wholesale {
    var $code;
    var $group;
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function __construct() {
      $this->code = get_class($this);
      $this->group = basename(dirname(__FILE__));

      $this->title = MODULE_CONTENT_HEADER_WHOLESALE_TITLE;
      $this->description = MODULE_CONTENT_HEADER_WHOLESALE_DESCRIPTION;
      $this->description .= '<p>by @raiwa <u><a target="_blank" href="http://www.oscaddons.com">www.oscaddons.com</a></u></p>';
      $this->description .= '<div class="secWarning">' . MODULE_CONTENT_BOOTSTRAP_ROW_DESCRIPTION . '</div>';

      if ( defined('MODULE_CONTENT_HEADER_WHOLESALE_STATUS') ) {
        $this->sort_order = MODULE_CONTENT_HEADER_WHOLESALE_SORT_ORDER;
        $this->enabled = (MODULE_CONTENT_HEADER_WHOLESALE_STATUS === 'True');
      }
    }

    
    function execute() {
      global $oscTemplate, $PHP_SELF, $lng, $language, $wholesale_group;

      if (tep_not_null(MODULE_CONTENT_HEADER_WHOLESALE_CONTENT_PAGES)) {
        $pages_array = array();

        foreach (explode(';', MODULE_CONTENT_HEADER_WHOLESALE_CONTENT_PAGES) as $page) {
          $page = trim($page);

          if (!empty($page)) {
            $pages_array[] = $page;
          }
        }

        if (in_array(basename($PHP_SELF), $pages_array)) {
      
        	$content_width = (int)MODULE_CONTENT_HEADER_WHOLESALE_CONTENT_WIDTH;
            
        	if (tep_session_is_registered('customer_id') && $wholesale_group > 0 ) {
        		$output = sprintf(constant('MODULE_CONTENT_HEADER_WHOLESALE_WSCUSTOMER_TEXT_' . strtoupper($language)), tep_href_link('contact_us.php'));
        	} else if ( tep_session_is_registered('customer_id') && !tep_session_is_registered('customer_is_guest') ) { //PWA guest checkout support do not show module to guests
        		$output = constant('MODULE_CONTENT_HEADER_WHOLESALE_RTCUSTOMER_TEXT_' . strtoupper($language));
        	} else {
        		$output = constant('MODULE_CONTENT_HEADER_WHOLESALE_GUEST_TEXT_' . strtoupper($language));
        	}
        	if ( $output != '' ) {
        	  
        		ob_start();
        		include('includes/modules/content/' . $this->group . '/templates/tpl_' . basename(__FILE__));
        		$template = ob_get_clean();

        		$oscTemplate->addContent($template, $this->group);
        	}
        }
      }
    }

    function isEnabled() {
    	if ( defined('MODULE_STORE_WHOLESALE_STATUS') && MODULE_STORE_WHOLESALE_STATUS == 'True' ) {
    		return $this->enabled;
    	} else {
    		$this->enabled = false;
    	}
    }

    function check() {
      return defined('MODULE_CONTENT_HEADER_WHOLESALE_STATUS');
    }

    function install() {
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Header Wholesale Message Module', 'MODULE_CONTENT_HEADER_WHOLESALE_STATUS', 'True', 'Do you want to enable the Wholesale Message content module?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Width', 'MODULE_CONTENT_HEADER_WHOLESALE_CONTENT_WIDTH', '12', 'What width container should the content be shown in?', '6', '2', 'tep_cfg_select_option(array(\'12\', \'11\', \'10\', \'9\', \'8\', \'7\', \'6\', \'5\', \'4\', \'3\', \'2\', \'1\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Align', 'MODULE_CONTENT_HEADER_WHOLESALE_CONTENT_ALIGN', 'text-center', 'How should the content be aligned?', '6', '3', 'tep_cfg_select_option(array(\'text-left\', \'text-center\', \'text-right\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Pages', 'MODULE_CONTENT_HEADER_WHOLESALE_CONTENT_PAGES', '" . implode(';', $this->get_default_pages()) . "', 'The pages to add the Holiday Message to.', '6', '4', 'cm_header_wholesales_show_pages', 'cm_header_wholesales_edit_pages(', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_CONTENT_HEADER_WHOLESALE_SORT_ORDER', '1000', 'Sort order of display. Lowest is displayed first.', '6', '5', now())");
      include('includes/classes/language.php');
      $lng = new language;
      foreach($lng->catalog_languages as $key => $value) {
      	$key = strtoupper($value['directory']);
        switch ($key) {
        	case 'ESPANOL':        
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Texto invitado " . $key . "', 'MODULE_CONTENT_HEADER_WHOLESALE_GUEST_TEXT_" . $key . "', '', 'Mensaje que se muestra a invitados en idioma " . $key . "', '6', '7', 'tep_cfg_module_textarea(', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Texto Cliente al menor " . $key . "', 'MODULE_CONTENT_HEADER_WHOLESALE_RTCUSTOMER_TEXT_" . $key . "', 'Bienvenido a su cuenta Minorista.<br>Por favor, <a class=\"btn btn-info btn-sm\" role=\"button\" href=\"contact_us.php\">Contáctenos</a> para solicitar una cuenta de Mayorista. Ver <a class=\"btn btn-info btn-sm\" role=\"button\" href=\"conditions.php\">Condiciones</a>.', 'Mensaje que se muestra a clientes al menor en idioma " . $key . "', '6', '8', 'tep_cfg_module_textarea(', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Texto cliente al mayor " . $key . "', 'MODULE_CONTENT_HEADER_WHOLESALE_WSCUSTOMER_TEXT_" . $key . "', 'Bienvenido a su cuenta Mayorista.<br>Puede ver sus Precios de Mayorista en la Página de Producto y se aplicarán cuando añada un Producto de su elección al Carrito de Compra.', 'Mensaje que se muestra a clientes al mayor en idioma" . $key . "', '6', '8', 'tep_cfg_module_textarea(', now())");
        		break;
        	case 'GERMAN':        
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Text für Gäste " . $key . "', 'MODULE_CONTENT_HEADER_WHOLESALE_GUEST_TEXT_" . $key . "', '', 'Text für Gäste in " . $key . " Sprache.', '6', '7', 'tep_cfg_module_textarea(', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Text für Einzelhändler " . $key . "', 'MODULE_CONTENT_HEADER_WHOLESALE_RTCUSTOMER_TEXT_" . $key . "', 'Willkommen zu Ihrem Einzelhändlerkonto.<br>Bitte <a class=\"btn btn-info btn-sm\" role=\"button\" href=\"contact_us.php\">Kontaktieren</a> Sie uns für ein Grosshändlerkonto. Siehe <a class=\"btn btn-info btn-sm\" role=\"button\" href=\"conditions.php\">Konditionen</a>.', 'Text für Einzelhändler in " . $key . " Sprache.', '6', '8', 'tep_cfg_module_textarea(', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Text für Grosshändler " . $key . "', 'MODULE_CONTENT_HEADER_WHOLESALE_WSCUSTOMER_TEXT_" . $key . "', 'Willkommen zu Ihrem Grosshändlerkonto.<br>Sie können Ihre Grosshändlerpreise auf der Produkt-Seite sehen, und sie werden angerechnet, wenn Sie die Produkte Ihrer Wahl in den Warenkorb legen.', 'Text für Grosshändler in " . $key . " Sprache.', '6', '8', 'tep_cfg_module_textarea(', now())");
        		break;
        	default:        
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Guest text " . $key . "', 'MODULE_CONTENT_HEADER_WHOLESALE_GUEST_TEXT_" . $key . "', '', 'Text shown to guests for " . $key . " language.', '6', '7', 'tep_cfg_module_textarea(', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Retail customer Text " . $key . "', 'MODULE_CONTENT_HEADER_WHOLESALE_RTCUSTOMER_TEXT_" . $key . "', 'Welcome to your Retailer Account.<br>Please <a class=\"btn btn-info btn-sm\" role=\"button\" href=\"contact_us.php\">Contact Us</a> to apply for a Wholesaler Account. See <a class=\"btn btn-info btn-sm\" role=\"button\" href=\"conditions.php\">Conditions</a>.', 'Text shown to retail customers for " . $key . " language.', '6', '8', 'tep_cfg_module_textarea(', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Wholesale customer Text " . $key . "', 'MODULE_CONTENT_HEADER_WHOLESALE_WSCUSTOMER_TEXT_" . $key . "', 'Welcome to your Wholesaler Account.<br>You can see your Wholesaler Prices on the Product Page and they will apply when you add the products of your choice to the Shopping Cart.', 'Text shown to wholesale customers for " . $key . " language.', '6', '8', 'tep_cfg_module_textarea(', now())");
        }
      }
    }
    
    function remove() {
      tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      include('includes/classes/language.php');
      $lng = new language;
      $KeysArray = array('MODULE_CONTENT_HEADER_WHOLESALE_STATUS', 'MODULE_CONTENT_HEADER_WHOLESALE_CONTENT_PAGES', 'MODULE_CONTENT_HEADER_WHOLESALE_CONTENT_WIDTH', 'MODULE_CONTENT_HEADER_WHOLESALE_CONTENT_ALIGN', 'MODULE_CONTENT_HEADER_WHOLESALE_SORT_ORDER');
      foreach($lng->catalog_languages as $key => $value) {
      	$key = strtoupper($value['directory']);
      	array_push($KeysArray, 'MODULE_CONTENT_HEADER_WHOLESALE_GUEST_TEXT_' . $key);
      	array_push($KeysArray, 'MODULE_CONTENT_HEADER_WHOLESALE_RTCUSTOMER_TEXT_' . $key);
      	array_push($KeysArray, 'MODULE_CONTENT_HEADER_WHOLESALE_WSCUSTOMER_TEXT_' . $key);
      }
      return $KeysArray;
    }
    
    function get_default_pages() {
    	global $PHP_SELF;
    	$exclude_array = array('checkout_process.php',
                   					 'download.php',
                   					 'redirect.php',
                   					 'ssl_check.php');
    	$file_extension = substr($PHP_SELF, strrpos($PHP_SELF, '.'));
    	$files_array = array();
    	if ($dir = @dir(DIR_FS_CATALOG)) {
    		while ($file = $dir->read()) {
    			if ( !is_dir(DIR_FS_CATALOG . $file) && !in_array($file, $exclude_array) ) {
    				if (substr($file, strrpos($file, '.')) == $file_extension) {
    					$files_array[] = $file;
    				}
    			}
    		}
    		sort($files_array);
    		$dir->close();
    		return $files_array;
    	}
    }
  }

  function cm_header_wholesales_show_pages($text) {
  	return nl2br(implode("\n", explode(';', $text)));
  }

  function cm_header_wholesales_edit_pages($values, $key) {
    global $PHP_SELF;

    $file_extension = substr($PHP_SELF, strrpos($PHP_SELF, '.'));
    $files_array = array();
	  if ($dir = @dir(DIR_FS_CATALOG)) {
	    while ($file = $dir->read()) {
	      if (!is_dir(DIR_FS_CATALOG . $file)) {
	        if (substr($file, strrpos($file, '.')) == $file_extension) {
            $files_array[] = $file;
          }
        }
      }
      sort($files_array);
      $dir->close();
    }

    $values_array = explode(';', $values);

    $output = '';
    foreach ($files_array as $file) {
      $output .= tep_draw_checkbox_field('cm_wholesale_file[]', $file, in_array($file, $values_array)) . '&nbsp;' . tep_output_string($file) . '<br />';
    }

    if (!empty($output)) {
      $output = '<br />' . substr($output, 0, -6);
    }

    $output .= tep_draw_hidden_field('configuration[' . $key . ']', '', 'id="htrn_files"');

    $output .= '<script>
                function htrn_update_cfg_value() {
                  var htrn_selected_files = \'\';

                  if ($(\'input[name="cm_wholesale_file[]"]\').length > 0) {
                    $(\'input[name="cm_wholesale_file[]"]:checked\').each(function() {
                      htrn_selected_files += $(this).attr(\'value\') + \';\';
                    });

                    if (htrn_selected_files.length > 0) {
                      htrn_selected_files = htrn_selected_files.substring(0, htrn_selected_files.length - 1);
                    }
                  }

                  $(\'#htrn_files\').val(htrn_selected_files);
                }

                $(function() {
                  htrn_update_cfg_value();

                  if ($(\'input[name="cm_wholesale_file[]"]\').length > 0) {
                    $(\'input[name="cm_wholesale_file[]"]\').change(function() {
                      htrn_update_cfg_value();
                    });
                  }
                });
                </script>';

    return $output;
  }

 function tep_cfg_module_textarea($text, $key = '') {
   $name = (($key) ? 'configuration[' . $key . ']' : 'configuration_value');
   return tep_draw_textarea_field($name, false, 35, 5, $text, 'style="font: inherit;"');
 }
