<?php
/*
  $Id: st_wholesale.php
  $Loc: catalog/includes/modules/store/

  wholesale (SPPC Lite) 4.0.0 
  by @raiwa 
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2019 Rainer Schmied
  All rights reserved.﻿﻿

  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

  3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

  class st_wholesale {
    var $code = 'st_wholesale';
    var $group = 'header_tags';
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function __construct() {
      $this->title = MODULE_STORE_WHOLESALE_TITLE;
      $this->description = MODULE_STORE_WHOLESALE_DESCRIPTION;
      $this->description .= '<p>by @raiwa <u><a target="_blank" href="http://www.oscaddons.com">www.oscaddons.com</a></u></p>';
      $this->description .= '<div class="secWarning"><a target="_blank" href="http://www.oscaddons.com/en/commercial-add-ons/wholesale-pro-p-45.html">GET WHOLESALE PRO</a><br>
                            - Unlimited Wholesaler Groups<br>
                            - Global Price Break Discounts<br>
                            </div>';

      if ( defined('MODULE_STORE_WHOLESALE_STATUS') ) {
        $this->sort_order = MODULE_STORE_WHOLESALE_SORT_ORDER;
        $this->enabled = (MODULE_STORE_WHOLESALE_STATUS == 'True');
      }
    }

    function execute() {
      global $PHP_SELF, $cart, $currencies, $customer_id, $shipping_modules, $quotes, $payment_modules, $wholesale_group, $payment;
      
    	if (tep_session_is_registered('customer_id')) {
        $check_customer_query = tep_db_query("select customers_wholesale from customers where customers_id = '" . (int)$customer_id . "'");
        $check_customer = tep_db_fetch_array($check_customer_query);
        if (!tep_session_is_registered('wholesale_group')) {
            tep_session_register('wholesale_group');
            $wholesale_group = $check_customer['customers_wholesale'];
        }
        if ($wholesale_group > 0 ) {
          $cart = new shoppingCartMod();
        }
      }

      if ( (basename($PHP_SELF) == 'shopping_cart.php' || basename($PHP_SELF)) == 'checkout_shipping.php' && class_exists('shipping') ) {
        $shipping_modules = new shipping_ws;
        $quotes = $shipping_modules->quote();
      }

      if ( (basename($PHP_SELF) == 'shopping_cart.php' || basename($PHP_SELF)) == 'checkout_payment.php' && class_exists('payment') ) {
        $payment_modules = new payment_ws;
      }
      
      if ( basename($PHP_SELF) == 'checkout_confirmation.php' && class_exists('payment') ) {
        $payment_modules = new payment_ws($payment);
      }

      if ( basename($PHP_SELF) == 'logoff.php' && tep_session_is_registered('wholesale_group') ) {
        tep_session_unregister('wholesale_group');
      }

    }

    function isEnabled() {    	
    	return $this->enabled;
    }
    
    function check() {
      return defined('MODULE_STORE_WHOLESALE_STATUS');
    }

    function install() {
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Current Version', 'MODULE_STORE_WHOLESALE_VERSION_INSTALLED', 'Version 3.0.3 Lite', 'Version info. It is read only.', '6', '1', 'tep_readonly(', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Wholesale Module', 'MODULE_STORE_WHOLESALE_STATUS', 'True', 'Do you want to add Wholesale Prices to your shop?', '6', '2', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Uninstall Removes Database entries', 'MODULE_STORE_WHOLESALE_REMOVE_DATA', 'False', 'Do you want to remove the wholesale database entries when uninstall the module? (wholesale customers,  wholesale product prices and wholesale attribute prices will be lost)', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Global Wholesale Discount', 'MODULE_STORE_WHOLESALE_GLOBAL_DISCOUNT', '10', 'Global Wholesale percentage Discount for all products with individual Wholesale Price zero. Disabled with zero amount.', '6', '5', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Tax Exempt Wholesalers', 'MODULE_STORE_WHOLESALE_TAX_EXEMPT', 'True', 'Do you want to exempt wholesales from taxes?', '6', '6', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Use Special Price', 'MODULE_STORE_WHOLESALE_SPECIAL_PRICE', 'True', 'Do you want to use special price if less than wholesale price?', '6', '7', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Wholesaler Exclude Shipping Modules', 'MODULE_STORE_WHOLESALE_WHOLESALER_SHIPPING_MODULES', '', 'The shipping modules to exclude for wholesalers.<br>Needs shipping class to be modified, see Instructions Step 5', '6', '8', 'st_wholesaler_show_shipping_modules', 'st_wholesaler_edit_shipping_modules(', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Retailer Exclude Shipping Modules', 'MODULE_STORE_WHOLESALE_RETAILER_SHIPPING_MODULES', '', 'The shipping modules to exclude for retailers.<br>Needs shipping class to be modified, see Instructions Step 5', '6', '9', 'st_retailer_show_shipping_modules', 'st_retailer_edit_shipping_modules(', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Wholesaler Exclude Payment Modules', 'MODULE_STORE_WHOLESALE_WHOLESALER_PAYMENT_MODULES', '', 'The payment modules to exclude for wholesalers.<br>Needs payment class to be modified, see Instructions Step 6', '6', '10', 'st_wholesaler_show_payment_modules', 'st_wholesaler_edit_payment_modules(', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Retailer Exclude Payment Modules', 'MODULE_STORE_WHOLESALE_RETAILER_PAYMENT_MODULES', '', 'The payment modules to exclude for retailers.<br>Needs payment class to be modified, see Instructions Step 6', '6', '11', 'st_retailer_show_payment_modules', 'st_retailer_edit_payment_modules(', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_STORE_WHOLESALE_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '12', now())");
      include_once('includes/classes/language.php');
      $lng = new language;
      foreach($lng->catalog_languages as $key => $value) {
      	$key = strtoupper($value['directory']);
        switch ($key) {
        	case 'ESPANOL':        
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Precio al Mayor (Net) " . $key . "', 'MODULE_STORE_WHOLESALE_PRICE_NET_" . $key . "', 'Precio al Mayor (Net):', 'Definición de idioma usado en categories.php', '6', '13', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Precio al Mayor (Gross) " . $key . "', 'MODULE_STORE_WHOLESALE_PRICE_GROSS_" . $key . "', 'Precio al Mayor (Gross):', 'Definición de idioma usado en categories.php', '6', '14', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Grupo clientes " . $key . "', 'MODULE_STORE_WHOLESALE_ENTRY_GROUP_" . $key . "', 'Grupo clientes', 'Definición de idioma usado en customers.php', '6', '15', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Mayorista " . $key . "', 'MODULE_STORE_WHOLESALE_ENTRY_WHOLESALE_" . $key . "', 'Mayorista', 'Definición de idioma usado en customers.php', '6', '16', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Minorista " . $key . "', 'MODULE_STORE_WHOLESALE_ENTRY_RETAIL_" . $key . "', 'Minorista', 'Definición de idioma usado en customers.php', '6', '17', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Precio al Mayor " . $key . "', 'MODULE_STORE_WHOLESALE_OPT_PRICE_" . $key . "', 'Precio al Mayor', 'Definición de idioma usado en products_attributes.php', '6', '18', now())");
         		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Precio al Mayor corto " . $key . "', 'MODULE_STORE_WHOLESALE_OPT_PRICE_SHORT_" . $key . "', 'PM', 'Definición de idioma usado como Prefijo del Precio al Mayor en la tienda', '6', '18', now())");
       		break;
        	case 'GERMAN':        
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Grosshändlerpreis (Netto) " . $key . "', 'MODULE_STORE_WHOLESALE_PRICE_NET_" . $key . "', 'Grosshändlerpreis (Netto):', 'Sprachdefinition für categories.php', '6', '19', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Grosshändlerpreis (Brutto ) " . $key . "', 'MODULE_STORE_WHOLESALE_PRICE_GROSS_" . $key . "', 'Grosshändlerpreis (Brutto):', 'Sprachdefinition für categories.php', '6', '20', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Kundengruppe " . $key . "', 'MODULE_STORE_WHOLESALE_ENTRY_GROUP_" . $key . "', 'Kundengruppe', 'Sprachdefinition für customers.php', '6', '21', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Grosshändler " . $key . "', 'MODULE_STORE_WHOLESALE_ENTRY_WHOLESALE_" . $key . "', 'Grosshändler', 'Sprachdefinition für customers.php', '6', '22', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Einzelhändler " . $key . "', 'MODULE_STORE_WHOLESALE_ENTRY_RETAIL_" . $key . "', 'Einzelhändler', 'Sprachdefinition für customers.php', '6', '23', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Grosshändlerpreis " . $key . "', 'MODULE_STORE_WHOLESALE_OPT_PRICE_" . $key . "', 'Grosshändlerpreis', 'Sprachdefinition für products_attributes.php', '6', '24', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Grosshändlerpreis kurz " . $key . "', 'MODULE_STORE_WHOLESALE_OPT_PRICE_SHORT_" . $key . "', 'GHP', 'Sprachdefinition für Abkürzung Grosshändlerpreis vor Preisen im Onlinestore', '6', '24', now())");
            break;
        	default:        
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Products Price (Net) " . $key . "', 'MODULE_STORE_WHOLESALE_PRICE_NET_" . $key . "', 'Wholesale Price (Net):', 'Language definition used in categories.php', '6', '25', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Products Price (Gross) " . $key . "', 'MODULE_STORE_WHOLESALE_PRICE_GROSS_" . $key . "', 'Wholesale (Gross):', 'Language definition used in categories.php', '6', '26', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Customer Group " . $key . "', 'MODULE_STORE_WHOLESALE_ENTRY_GROUP_" . $key . "', 'Customer Group', 'Language definition used in customers.php', '6', '27', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Wholesaler " . $key . "', 'MODULE_STORE_WHOLESALE_ENTRY_WHOLESALE_" . $key . "', 'Wholesaler', 'Language definition used in customers.php', '6', '28', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Retailer " . $key . "', 'MODULE_STORE_WHOLESALE_ENTRY_RETAIL_" . $key . "', 'Retailer', 'Language definition used in customers.php', '6', '29', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Wholesale Price " . $key . "', 'MODULE_STORE_WHOLESALE_OPT_PRICE_" . $key . "', 'Wholesale Price', 'Language definition used in products_attributes.php', '6', '30', now())");
        		tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Wholesale Price Short " . $key . "', 'MODULE_STORE_WHOLESALE_OPT_PRICE_SHORT_" . $key . "', 'WP', 'Language definition used for Whlolesale Price Prefix in Store', '6', '30', now())");
        }
      }


      if ( defined('TEMPLATE_BLOCK_GROUPS') ) {
      	// If header_tags is not the first item on the list
        if( substr( TEMPLATE_BLOCK_GROUPS, 0, 11 ) != 'store' ) {
        	// Remove header_tags from wherever it is in the list
        	$template_block_groups = str_replace( ';store', '', TEMPLATE_BLOCK_GROUPS );
        	// And add header_tags back onto the front of the list
        	$template_block_groups = 'store;' . $template_block_groups;
        	$sql_data_array = array( 'configuration_value' => $template_block_groups );
        	// Update the database with the fixed string
        	tep_db_perform( 'configuration', $sql_data_array, 'update', "configuration_key = 'TEMPLATE_BLOCK_GROUPS'" );
        } // if( substr
      } // end if defined TEMPLATE_BLOCK_GROUPS

      //install database columns
      if (tep_db_num_rows(tep_db_query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='customers' AND COLUMN_NAME LIKE 'customers_wholesale'")) != 1 ) {
      tep_db_query("ALTER TABLE `customers` ADD COLUMN `customers_wholesale` CHAR(1) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL");
      }
      // install products_ws_price columns
      if (tep_db_num_rows(tep_db_query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products' AND COLUMN_NAME LIKE 'products_ws_price'")) != 1 ) {
        tep_db_query("alter table products add column `products_ws_price` DECIMAL(15,4) NOT NULL AFTER products_price");
      }      
      // install options_values_ws_price columns
      if (tep_db_num_rows(tep_db_query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_attributes' AND COLUMN_NAME LIKE 'options_values_ws_price'")) != 1 ) {
        tep_db_query("alter table products_attributes add column `options_values_ws_price` DECIMAL(15,4) NOT NULL AFTER options_values_price");
      }      
    } // end install

    function remove() {
      if ( defined('MODULE_STORE_WHOLESALE_REMOVE_DATA') && MODULE_STORE_WHOLESALE_REMOVE_DATA == 'True' ) {
      	tep_db_query("alter table customers drop `customers_wholesale`");
      	tep_db_query("alter table products drop `products_ws_price`");
      	tep_db_query("alter table products_attributes drop `options_values_ws_price`");
      }
      tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      include_once('includes/classes/language.php');
      $lng = new language;
      $KeysArray = array('MODULE_STORE_WHOLESALE_VERSION_INSTALLED', 'MODULE_STORE_WHOLESALE_STATUS', 'MODULE_STORE_WHOLESALE_REMOVE_DATA', 'MODULE_STORE_WHOLESALE_GLOBAL_DISCOUNT');
      $KeysArray2 = array('MODULE_STORE_WHOLESALE_TAX_EXEMPT', 'MODULE_STORE_WHOLESALE_SPECIAL_PRICE', 'MODULE_STORE_WHOLESALE_WHOLESALER_SHIPPING_MODULES', 'MODULE_STORE_WHOLESALE_RETAILER_SHIPPING_MODULES', 'MODULE_STORE_WHOLESALE_WHOLESALER_PAYMENT_MODULES', 'MODULE_STORE_WHOLESALE_RETAILER_PAYMENT_MODULES', 'MODULE_STORE_WHOLESALE_SORT_ORDER');
      $KeysArray = array_merge($KeysArray, $KeysArray2);
      
      foreach($lng->catalog_languages as $key => $value) {
      	$key = strtoupper($value['directory']);
      	array_push($KeysArray, 'MODULE_STORE_WHOLESALE_PRICE_NET_' . $key);
      	array_push($KeysArray, 'MODULE_STORE_WHOLESALE_PRICE_GROSS_' . $key);
      	array_push($KeysArray, 'MODULE_STORE_WHOLESALE_ENTRY_GROUP_' . $key);
      	array_push($KeysArray, 'MODULE_STORE_WHOLESALE_ENTRY_WHOLESALE_' . $key);
      	array_push($KeysArray, 'MODULE_STORE_WHOLESALE_ENTRY_RETAIL_' . $key);
      	array_push($KeysArray, 'MODULE_STORE_WHOLESALE_OPT_PRICE_' . $key);
      	array_push($KeysArray, 'MODULE_STORE_WHOLESALE_OPT_PRICE_SHORT_' . $key);
      }
      return $KeysArray;
    }
  }
 
// wholesaler_shipping_modules Begin  
  function st_wholesaler_show_shipping_modules($text) {
    return nl2br(implode("\n", explode(';', $text)));
  }

  function st_wholesaler_edit_shipping_modules($values, $key) {
    global $PHP_SELF;

    $file_extension = substr($PHP_SELF, strrpos($PHP_SELF, '.'));
    $files_array = array();
	  if ($dir = @dir(DIR_FS_CATALOG . 'includes/modules/shipping/')) {
	    while ($file = $dir->read()) {
	      if (!is_dir(DIR_FS_CATALOG . 'includes/modules/shipping/' . $file)) {
	        if (substr($file, strrpos($file, '.')) == $file_extension) {
            $files_array[] = $file;
          }
        }
      }
      sort($files_array);
      $dir->close();
    }

    $values_array = explode(';', $values);
    $installed_values = explode(';', MODULE_SHIPPING_INSTALLED);

    $output = '';
    foreach ($files_array as $file) {
    	if ( in_array($file, $installed_values ) ) {
    		$output .= tep_draw_checkbox_field('st_wholesaler_shipping_module[]', $file, in_array($file, $values_array), null, True) . '&nbsp;' . tep_output_string($file) . '<br />';
    	}
    }

    if (!empty($output)) {
      $output = '<br />' . substr($output, 0, -6);
    }

    $output .= tep_draw_hidden_field('configuration[' . $key . ']', '', 'id="htrn_wholesaler_shipping_modules"');

    $output .= '<script>
                function htrn_wholesaler_shipping_update_cfg_value() {
                  var htrn_wholesaler_shipping_selected_modules = \'\';

                  if ($(\'input[name="st_wholesaler_shipping_module[]"]\').length > 0) {
                    $(\'input[name="st_wholesaler_shipping_module[]"]:checked\').each(function() {
                      htrn_wholesaler_shipping_selected_modules += $(this).attr(\'value\') + \';\';
                    });

                    if (htrn_wholesaler_shipping_selected_modules.length > 0) {
                      htrn_wholesaler_shipping_selected_modules = htrn_wholesaler_shipping_selected_modules.substring(0, htrn_wholesaler_shipping_selected_modules.length - 1);
                    }
                  }

                  $(\'#htrn_wholesaler_shipping_modules\').val(htrn_wholesaler_shipping_selected_modules);
                }

                $(function() {
                  htrn_wholesaler_shipping_update_cfg_value();

                  if ($(\'input[name="st_wholesaler_shipping_module[]"]\').length > 0) {
                    $(\'input[name="st_wholesaler_shipping_module[]"]\').change(function() {
                      htrn_wholesaler_shipping_update_cfg_value();
                    });
                  }
                });
                </script>';

    return $output;
  }
// wholesaler_shipping_modules End  

// retailer_shipping_modules Begin  
  function st_retailer_show_shipping_modules($text) {
    return nl2br(implode("\n", explode(';', $text)));
  }

  function st_retailer_edit_shipping_modules($values, $key) {
    global $PHP_SELF;

    $file_extension = substr($PHP_SELF, strrpos($PHP_SELF, '.'));
    $files_array = array();
	  if ($dir = @dir(DIR_FS_CATALOG . 'includes/modules/shipping/')) {
	    while ($file = $dir->read()) {
	      if (!is_dir(DIR_FS_CATALOG . 'includes/modules/shipping/' . $file)) {
	        if (substr($file, strrpos($file, '.')) == $file_extension) {
            $files_array[] = $file;
          }
        }
      }
      sort($files_array);
      $dir->close();
    }

    $values_array = explode(';', $values);
    $installed_values = explode(';', MODULE_SHIPPING_INSTALLED);

    $output = '';
    foreach ($files_array as $file) {
    	if ( in_array($file, $installed_values ) ) {
    		$output .= tep_draw_checkbox_field('st_retailer_shipping_module[]', $file, in_array($file, $values_array), null, True) . '&nbsp;' . tep_output_string($file) . '<br />';
    	}
    }

    if (!empty($output)) {
      $output = '<br />' . substr($output, 0, -6);
    }

    $output .= tep_draw_hidden_field('configuration[' . $key . ']', '', 'id="htrn_retailer_shipping_modules"');

    $output .= '<script>
                function htrn_retailer_shipping_update_cfg_value() {
                  var htrn_retailer_shipping_selected_modules = \'\';

                  if ($(\'input[name="st_retailer_shipping_module[]"]\').length > 0) {
                    $(\'input[name="st_retailer_shipping_module[]"]:checked\').each(function() {
                      htrn_retailer_shipping_selected_modules += $(this).attr(\'value\') + \';\';
                    });

                    if (htrn_retailer_shipping_selected_modules.length > 0) {
                      htrn_retailer_shipping_selected_modules = htrn_retailer_shipping_selected_modules.substring(0, htrn_retailer_shipping_selected_modules.length - 1);
                    }
                  }

                  $(\'#htrn_retailer_shipping_modules\').val(htrn_retailer_shipping_selected_modules);
                }

                $(function() {
                  htrn_retailer_shipping_update_cfg_value();

                  if ($(\'input[name="st_retailer_shipping_module[]"]\').length > 0) {
                    $(\'input[name="st_retailer_shipping_module[]"]\').change(function() {
                      htrn_retailer_shipping_update_cfg_value();
                    });
                  }
                });
                </script>';

    return $output;
  }
// retailer_shipping_modules End  

// wholesaler_payment_modules Begin    
  function st_wholesaler_show_payment_modules($text) {
    return nl2br(implode("\n", explode(';', $text)));
  }

  function st_wholesaler_edit_payment_modules($values, $key) {
    global $PHP_SELF;

    $file_extension = substr($PHP_SELF, strrpos($PHP_SELF, '.'));
    $files_array = array();
	  if ($dir = @dir(DIR_FS_CATALOG . 'includes/modules/payment/')) {
	    while ($file = $dir->read()) {
	      if (!is_dir(DIR_FS_CATALOG . 'includes/modules/payment/' . $file)) {
	        if (substr($file, strrpos($file, '.')) == $file_extension) {
            $files_array[] = $file;
          }
        }
      }
      sort($files_array);
      $dir->close();
    }

    $values_array = explode(';', $values);
    $installed_values = explode(';', MODULE_PAYMENT_INSTALLED);

    $output = '';
    foreach ($files_array as $file) {
    	if ( in_array($file, $installed_values ) ) {
    		$output .= tep_draw_checkbox_field('st_wholesaler_payment_module[]', $file, in_array($file, $values_array), null, True) . '&nbsp;' . tep_output_string($file) . '<br />';
    	}
    }

    if (!empty($output)) {
      $output = '<br />' . substr($output, 0, -6);
    }

    $output .= tep_draw_hidden_field('configuration[' . $key . ']', '', 'id="htrn_wholesaler_payment_modules"');

    $output .= '<script>
                function htrn_wholesaler_payment_update_cfg_value() {
                  var htrn_wholesaler_payment_selected_modules = \'\';

                  if ($(\'input[name="st_wholesaler_payment_module[]"]\').length > 0) {
                    $(\'input[name="st_wholesaler_payment_module[]"]:checked\').each(function() {
                      htrn_wholesaler_payment_selected_modules += $(this).attr(\'value\') + \';\';
                    });

                    if (htrn_wholesaler_payment_selected_modules.length > 0) {
                      htrn_wholesaler_payment_selected_modules = htrn_wholesaler_payment_selected_modules.substring(0, htrn_wholesaler_payment_selected_modules.length - 1);
                    }
                  }

                  $(\'#htrn_wholesaler_payment_modules\').val(htrn_wholesaler_payment_selected_modules);
                }

                $(function() {
                  htrn_wholesaler_payment_update_cfg_value();

                  if ($(\'input[name="st_wholesaler_payment_module[]"]\').length > 0) {
                    $(\'input[name="st_wholesaler_payment_module[]"]\').change(function() {
                      htrn_wholesaler_payment_update_cfg_value();
                    });
                  }
                });
                </script>';

    return $output;
  }
// wholesaler_payment_modules End

// retailer_payment_modules Begin      
  function st_retailer_show_payment_modules($text) {
    return nl2br(implode("\n", explode(';', $text)));
  }

  function st_retailer_edit_payment_modules($values, $key) {
    global $PHP_SELF;

    $file_extension = substr($PHP_SELF, strrpos($PHP_SELF, '.'));
    $files_array = array();
	  if ($dir = @dir(DIR_FS_CATALOG . 'includes/modules/payment/')) {
	    while ($file = $dir->read()) {
	      if (!is_dir(DIR_FS_CATALOG . 'includes/modules/payment/' . $file)) {
	        if (substr($file, strrpos($file, '.')) == $file_extension) {
            $files_array[] = $file;
          }
        }
      }
      sort($files_array);
      $dir->close();
    }

    $values_array = explode(';', $values);
    $installed_values = explode(';', MODULE_PAYMENT_INSTALLED);

    $output = '';
    foreach ($files_array as $file) {
    	if ( in_array($file, $installed_values ) ) {
    		$output .= tep_draw_checkbox_field('st_retailer_payment_module[]', $file, in_array($file, $values_array), null, True) . '&nbsp;' . tep_output_string($file) . '<br />';
    	}
    }

    if (!empty($output)) {
      $output = '<br />' . substr($output, 0, -6);
    }

    $output .= tep_draw_hidden_field('configuration[' . $key . ']', '', 'id="htrn_retailer_payment_modules"');

    $output .= '<script>
                function htrn_retailer_payment_update_cfg_value() {
                  var htrn_retailer_payment_selected_modules = \'\';

                  if ($(\'input[name="st_retailer_payment_module[]"]\').length > 0) {
                    $(\'input[name="st_retailer_payment_module[]"]:checked\').each(function() {
                      htrn_retailer_payment_selected_modules += $(this).attr(\'value\') + \';\';
                    });

                    if (htrn_retailer_payment_selected_modules.length > 0) {
                      htrn_retailer_payment_selected_modules = htrn_retailer_payment_selected_modules.substring(0, htrn_retailer_payment_selected_modules.length - 1);
                    }
                  }

                  $(\'#htrn_retailer_payment_modules\').val(htrn_retailer_payment_selected_modules);
                }

                $(function() {
                  htrn_retailer_payment_update_cfg_value();

                  if ($(\'input[name="st_retailer_payment_module[]"]\').length > 0) {
                    $(\'input[name="st_retailer_payment_module[]"]\').change(function() {
                      htrn_retailer_payment_update_cfg_value();
                    });
                  }
                });
                </script>';

    return $output;
  }
// retailer_payment_modules End

// function show the version read only  
  if(!function_exists('tep_readonly')) {
  	function tep_readonly($value){
  		$version_text = $value;
      return $version_text;
    }
  }    

  	function wholesale_price($product_id){
      global $currencies, $language, $wholesale_group, $customer_id;
      $product_info_ws_query = tep_db_query("select products_price, products_tax_class_id, products_ws_price
        																						from products
        																						where products_status = '1' and products_id = '" . (int)$product_id . "'
        																		");

      $product_info_ws = tep_db_fetch_array($product_info_ws_query);
      
    	$specials_query = tep_db_query("select specials_new_products_price from specials where products_id = '" . (int)$product_id . "' and status = '1'");
      if (tep_db_num_rows($specials_query)) {
        $specials = tep_db_fetch_array($specials_query);
      }
    	if ( tep_session_is_registered('customer_id') && defined('MODULE_STORE_WHOLESALE_STATUS') && MODULE_STORE_WHOLESALE_STATUS == 'True' && $wholesale_group > '0' ) {
    		if ( $product_info_ws['products_ws_price'] > 0 ) { // apply individual wholesale price
    			$products_ws_price = $product_info_ws['products_ws_price'];
    		} else if ( MODULE_STORE_WHOLESALE_GLOBAL_DISCOUNT > 0 ) { // apply global wholesale price discount
    			$products_ws_price = $product_info_ws['products_price'] - ($product_info_ws['products_price'] * MODULE_STORE_WHOLESALE_GLOBAL_DISCOUNT/100);
    		} else { // apply retail price
    			$products_ws_price = $product_info_ws['products_price'];
    		}
        if ( isset($specials) && ($specials['specials_new_products_price'] < $products_ws_price)
              && (defined('MODULE_STORE_WHOLESALE_SPECIAL_PRICE') && MODULE_STORE_WHOLESALE_SPECIAL_PRICE == 'True') ) { // apply special price as wholesale price
          $products_ws_price = $specials['specials_new_products_price'];
        }
      	if (MODULE_STORE_WHOLESALE_TAX_EXEMPT == 'True') { // exempt wholesale customers from tax
      		$products_ws_price = constant('MODULE_STORE_WHOLESALE_OPT_PRICE_SHORT_' . strtoupper($language)) . ' ' . $currencies->display_price($products_ws_price, 0);
      	} else { // apply standard tax
      		$products_ws_price = constant('MODULE_STORE_WHOLESALE_OPT_PRICE_SHORT_' . strtoupper($language)) . ' ' . $currencies->display_price($products_ws_price, tep_get_tax_rate($product_info_ws['products_tax_class_id']));
      	}
      } else {
      	$products_ws_price = $product_info_ws['products_price'];
      	if ( isset($specials) && $specials['specials_new_products_price'] )
      		$products_ws_price = $specials['specials_new_products_price'];
      	$products_ws_price = $currencies->display_price($products_ws_price, tep_get_tax_rate($product_info_ws['products_tax_class_id']));
      }
      return $products_ws_price;
    }
    
// Begin wholesale (SPPC Lite) shipping class extension
  if (class_exists('shipping')) {
    class shipping_ws extends shipping {
      public $modules;

// class constructor
      function __construct($module = '') {
        global $language, $PHP_SELF;
        global $customer_id; // wholesale (SPPC Lite)
  
        if (defined('MODULE_SHIPPING_INSTALLED') && tep_not_null(MODULE_SHIPPING_INSTALLED)) {
          // wholesale (SPPC Lite) BEGIN
          if ( defined('MODULE_STORE_WHOLESALE_STATUS') && MODULE_STORE_WHOLESALE_STATUS == 'True' ) {
            $check_customer_query = tep_db_query("select customers_wholesale from customers where customers_id = '" . (int)$customer_id . "'");
            $check_customer = tep_db_fetch_array($check_customer_query);
            $temp_shipment_array = null;
            if (tep_session_is_registered('customer_id') && $check_customer['customers_wholesale'] == '1' && tep_not_null(MODULE_STORE_WHOLESALE_WHOLESALER_SHIPPING_MODULES)) {
              $temp_shipment_array = explode(';', MODULE_STORE_WHOLESALE_WHOLESALER_SHIPPING_MODULES); // wholesalers exclude array
            } else if (tep_not_null(MODULE_STORE_WHOLESALE_RETAILER_SHIPPING_MODULES) ) {
              $temp_shipment_array = explode(';', MODULE_STORE_WHOLESALE_RETAILER_SHIPPING_MODULES); // retailers exclude array
            }
            if (tep_not_null($temp_shipment_array)) { // remove excluded shipping modules
              $installed_modules = explode(';', MODULE_SHIPPING_INSTALLED);
              for ($n = 0; $n < sizeof($installed_modules) ; $n++) {
                // check to see if a shipping module is not de-installed
                if ( !in_array($installed_modules[$n], $temp_shipment_array ) ) {
                  $shipment_array[] = $installed_modules[$n];
                }
              } // end for loop
              $this->modules = $shipment_array;
            } else { // default
              $this->modules = explode(';', MODULE_SHIPPING_INSTALLED); // original code
            }
          } else { // st_wholesale not enabled/installed
            $this->modules = explode(';', MODULE_SHIPPING_INSTALLED); //original code
          } 
          // wholesale (SPPC Lite) END
  
          $include_modules = array();
  
          if ( (tep_not_null($module)) && (in_array(substr($module['id'], 0, strpos($module['id'], '_')) . '.' . substr($PHP_SELF, (strrpos($PHP_SELF, '.')+1)), $this->modules)) ) {
            $include_modules[] = array('class' => substr($module['id'], 0, strpos($module['id'], '_')), 'file' => substr($module['id'], 0, strpos($module['id'], '_')) . '.' . substr($PHP_SELF, (strrpos($PHP_SELF, '.')+1)));
          } else {
            foreach($this->modules as $value) {
              $class = substr($value, 0, strrpos($value, '.'));
              $include_modules[] = array('class' => $class, 'file' => $value);
            }
          }
  
          for ($i=0, $n=sizeof($include_modules); $i<$n; $i++) {
            include_once('includes/languages/' . $language . '/modules/shipping/' . $include_modules[$i]['file']);
            include_once('includes/modules/shipping/' . $include_modules[$i]['file']);
            
            $GLOBALS[$include_modules[$i]['class']] = new $include_modules[$i]['class'];
          }
        }
      }
    } // end class
  } // end if class exists
// End shipping class extension      

// Begin wholesale (SPPC Lite) payment class extension
  if (class_exists('payment')) {
    class payment_ws extends payment {
      public $modules;
      public $selected_module;

// class constructor
      function __construct($module = '') {
        global $payment, $language, $PHP_SELF;
        global $customer_id; // wholesale (SPPC Lite)
  
        if (defined('MODULE_PAYMENT_INSTALLED') && tep_not_null(MODULE_PAYMENT_INSTALLED)) {
          // wholesale (SPPC Lite) BEGIN
          if ( defined('MODULE_STORE_WHOLESALE_STATUS') && MODULE_STORE_WHOLESALE_STATUS == 'True' ) {
            $check_customer_query = tep_db_query("select customers_wholesale from customers where customers_id = '" . (int)$customer_id . "'");
            $check_customer = tep_db_fetch_array($check_customer_query);
            $temp_payment_array = null;
            if (tep_session_is_registered('customer_id') && $check_customer['customers_wholesale'] == '1' && tep_not_null(MODULE_STORE_WHOLESALE_WHOLESALER_PAYMENT_MODULES)) {
              $temp_payment_array = explode(';', MODULE_STORE_WHOLESALE_WHOLESALER_PAYMENT_MODULES); // wholesalers exclude array
            } else if (tep_not_null(MODULE_STORE_WHOLESALE_RETAILER_PAYMENT_MODULES) ) {
              $temp_payment_array = explode(';', MODULE_STORE_WHOLESALE_RETAILER_PAYMENT_MODULES); // retailers exclude array
            }
            if (tep_not_null($temp_payment_array)) { // remove excluded shipping modules
              $installed_modules = explode(';', MODULE_PAYMENT_INSTALLED);
              for ($n = 0; $n < sizeof($installed_modules) ; $n++) {
                // check to see if a payment method is not de-installed
                if ( !in_array($installed_modules[$n], $temp_payment_array ) ) {
                  $payment_array[] = $installed_modules[$n];
                }
              } // end for loop
              $this->modules = $payment_array;
            } else { // default
              $this->modules = explode(';', MODULE_PAYMENT_INSTALLED); // original code
            }
          } else { // st_wholesale not enabled/installed
            $this->modules = explode(';', MODULE_PAYMENT_INSTALLED); //original code
          } 
          // wholesale (SPPC Lite) END
  
          $include_modules = array();
  
          if ( (tep_not_null($module)) && (in_array($module . '.' . substr($PHP_SELF, (strrpos($PHP_SELF, '.')+1)), $this->modules)) ) {
            $this->selected_module = $module;
  
            $include_modules[] = array('class' => $module, 'file' => $module . '.php');
          } else {
            foreach($this->modules as $value) {
              $class = substr($value, 0, strrpos($value, '.'));
              $include_modules[] = array('class' => $class, 'file' => $value);
            }
          }
  
          for ($i=0, $n=sizeof($include_modules); $i<$n; $i++) {
            include_once('includes/languages/' . $language . '/modules/payment/' . $include_modules[$i]['file']);
            include_once('includes/modules/payment/' . $include_modules[$i]['file']);
            
            $GLOBALS[$include_modules[$i]['class']] = new $include_modules[$i]['class'];
          }
  
  // if there is only one payment method, select it as default because in
  // checkout_confirmation.php the $payment variable is being assigned the
  // $_POST['payment'] value which will be empty (no radio button selection possible)
          if ( (tep_count_payment_modules() == 1) && (!isset($GLOBALS[$payment]) || (isset($GLOBALS[$payment]) && !is_object($GLOBALS[$payment]))) ) {
            $payment = $include_modules[0]['class'];
          }
  
          if ( (tep_not_null($module)) && (in_array($module, $this->modules)) && (isset($GLOBALS[$module]->form_action_url)) ) {
            $this->form_action_url = $GLOBALS[$module]->form_action_url;
          }
        }
      }
    } // end class
  } // end if class exists
// End payment class extension      
?>
